<?php
/**
 * @version		$Id$
 * @package		com_fjrelated_plus
 * @copyright	Copyright (C) 2008 Mark Dexter. Portions Copyright Open Source Matters. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl.html
 *
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'query.php');


/**
 * Related Articles Component Model
 *
 * @package		Related Articles
 *
 */
class FJRelatedModelFJRelated extends JModel
{
	/**
	 * id of "guide" Article
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * Related items list
	 *
	 * @var array
	 */

	/**
	 * Total number of related items
	 *
	 * @var integer
	 */
	var $_total = null;
	var $_data = null;

	/**
	 * Article content for Guide Article
	 *
	 * @var object
	 */
	var $_article = null;

	/**
	 * Array of FJ Related menu item links
	 *
	 * @var object
	 */
	var $_fjrelatedLinks = null;

	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		parent::__construct();

		global $mainframe;

		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
		$this->_loadArticle();

		// here we initialize defaults for related items model
		$params = &$mainframe->getParams();
	}
	/**
	 * Method to set the related items id
	 *
	 * @access	public
	 * @param	int	Related items ID number
	 */
	function setId($id)
	{
		// Set related ID and wipe data
		$this->_id			= $id;
		//$this->_article		= null;
		$this->_data		= array();
		$this->_total		= null;
	}
	/**
	 * Method to get content item data for the current related items list
	 *
	 * @param	int	$state	The content state to pull from for the current
	 * related list
	 */
	function getList($state = 1)
	{
		// Load the Category data
		$this->_loadData($state);
		return $this->_data[$state];
	}
	function &getArticle()
	{
		// Load the lead article data
		if ($this->_loadArticle())
		{
			$user	= & JFactory::getUser();

			// Is the category published?
			if (!$this->_article->cat_pub && $this->_article->catid) {
				JError::raiseError( 404, JText::_("Article category not published") );
			}

			// Is the section published?
			if ($this->_article->sectionid)
			{
				if ($this->_article->sec_pub === null)
				{
					// probably a new item
					// check the sectionid probably passed in the request
					$db =& $this->getDBO();
					$query = 'SELECT published' .
							' FROM #__sections' .
							' WHERE id = ' . (int) $this->_article->sectionid;
					$db->setQuery( $query );
					$this->_article->sec_pub = $db->loadResult();
				}
				if (!$this->_article->sec_pub)
				{
					JError::raiseError( 404, JText::_("Article section not published") );
				}
			}

			// Do we have access to the category?
			if (($this->_article->cat_access > $user->get('aid', 0)) && $this->_article->catid) {
				JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
			}

			// Do we have access to the section?
			if (($this->_article->sec_access > $user->get('aid', 0)) && $this->_article->sectionid) {
				JError::raiseError( 403, JText::_("ALERTNOTAUTH") );
			}

			$this->_loadArticleParams();
			// Process the content preparation plugins
			$dispatcher	=& JDispatcher::getInstance();
			JPluginHelper::importPlugin('content');
			$results = $dispatcher->trigger('onPrepareContent', array (& $this->_article, & $this->_article->parameters, 0));
			$this->_article->event = new stdClass();
			$results = $dispatcher->trigger('onAfterDisplayTitle', array (& $this->_article, & $this->_article->parameters,0));
			$this->_article->event->afterDisplayTitle = trim(implode("\n", $results));

			$results = $dispatcher->trigger('onBeforeDisplayContent', array (& $this->_article, & $this->_article->parameters, 0));
			$this->_article->event->beforeDisplayContent = trim(implode("\n", $results));

			$results = $dispatcher->trigger('onAfterDisplayContent', array (& $this->_article, & $this->_article->parameters, 0));
			$this->_article->event->afterDisplayContent = trim(implode("\n", $results));

		}
		else
		{
			$user =& JFactory::getUser();
			$article =& JTable::getInstance('content');
			$article->state			= 1;
			$article->cat_pub		= null;
			$article->sec_pub		= null;
			$article->cat_access	= null;
			$article->sec_access	= null;
			$article->author		= null;
			$article->created_by	= $user->get('id');
			$article->parameters	= new JParameter( '' );
			$article->text			= '';
			global $mainframe;
			$params = &$mainframe->getParams();
			$article->metakey		= $params->get('keywords');
			$this->_article			= $article;
			//$this->_article 		= null;
		}

		return $this->_article;
	}
	/**
	 * Method to get content item data for the current keywords
	 *
	 * @param	int	$state	The content state to pull from for the current
	 * category
	 * @since 1.5
	 */
	function getData($state = 1)
	{
		// Load the Related Items data
		$this->_loadData($state);


		return $this->_data[$state];
	}
	/**
	 * Method to get the total number of content items for the frontpage
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal($state = 1)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery($state);
			$this->_total[$state] = $this->_getListCount($query);
		}

		return $this->_total[$state];
	}

	/**
	 * Method to load content article data
	 *
	 * @access	private
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function _loadArticle()
	{
		global $mainframe;

		// Load the content if it doesn't already exist
		if (empty($this->_article))
		{
			// Get the page/component configuration
			$params = &$mainframe->getParams();

			// If voting is turned on, get voting data as well for the article
			$voting	= ContentHelperQuery::buildVotingQuery($params);

			// Get the WHERE clause
			$where	= $this->_buildContentWhere();

			$query = 'SELECT a.*, u.name AS author, u.usertype, cc.title AS category, s.title AS section,' .
					' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
					' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
					' g.name AS groups, s.published AS sec_pub, cc.published AS cat_pub, s.access AS sec_access, ' . 
					' cc.access AS cat_access '.$voting['select'].
					' FROM #__content AS a' .
					' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
					' LEFT JOIN #__sections AS s ON s.id = cc.section AND s.scope = "content"' .
					' LEFT JOIN #__users AS u ON u.id = a.created_by' .
					' LEFT JOIN #__groups AS g ON a.access = g.id'.
			$voting['join'].
			$where;
			$this->_db->setQuery($query);
			$this->_article = $this->_db->loadObject();

			if ( ! $this->_article ) {
				return false;
			}

			if($this->_article->publish_down == $this->_db->getNullDate()) {
				$this->_article->publish_down = JText::_('Never');
			}

			// These attributes need to be defined in order for the voting plugin to work
			if ( count($voting) && ! isset($this->_article->rating_count) ) {
				$this->_article->rating_count	= 0;
				$this->_article->rating			= 0;
			}

			return true;
		}
		return true;
	}

	/**
	 * Method to load content article parameters
	 *
	 * @access	private
	 * @return	void
	 * @since	1.5
	 */
	function _loadArticleParams()
	{
		global $mainframe;

		// Get the page/component configuration
		$params = clone($mainframe->getParams('com_content'));

		// Merge article parameters into the page configuration
		$aparams = new JParameter($this->_article->attribs);
		$params->merge($aparams);

		// Set the popup configuration option based on the request
		$pop = JRequest::getVar('pop', 0, '', 'int');
		$params->set('popup', $pop);

		// Are we showing introtext with the article
		if (!$params->get('show_intro') && !empty($this->_article->fulltext)) {
			$this->_article->text = $this->_article->fulltext;
		} else {
			$this->_article->text = $this->_article->introtext . chr(13).chr(13) . $this->_article->fulltext;
		}

		// Set the article object's parameters
		$this->_article->parameters = & $params;
	}

	/**
	 * Method to build the WHERE clause of the query to select a content article
	 *
	 * @access	private
	 * @return	string	WHERE clause
	 * @since	1.5
	 */
	function _buildContentWhere()
	{
		global $mainframe;

		$user		=& JFactory::getUser();
		$aid		= (int) $user->get('aid', 0);
		$id 		= JRequest::getVar('id', 0, '', 'int');

		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();
		$nullDate	= $this->_db->getNullDate();

		/*
		 * First thing we need to do is assert that the content article is the one
		 * we are looking for and we have access to it.
		 */
		$where = ' WHERE a.id = '. (int) $this->_id;
		//		$where .= ' AND a.access <= '. (int) $aid;

		if (!$user->authorize('com_content', 'edit', 'content', 'all'))
		{
			$where .= ' AND ( ';
			$where .= ' ( a.created_by = ' . (int) $user->id . ' ) ';
			$where .= '   OR ';
			$where .= ' ( a.state = 1' .
					' AND ( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' )' .
					' AND ( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' )';
			$where .= '   ) ';
			$where .= '   OR ';
			$where .= ' ( a.state = -1 ) ';
			$where .= ' ) ';
		}

		return $where;
	}

	function _buildQuery($state = 1)
	{
		global $mainframe;
		$params = &$mainframe->getParams();

		// If voting is turned on, get voting data as well for the content items
		$voting	= ContentHelperQuery::buildVotingQuery($params);

		$metakey = trim($this->_article->metakey);
		
		$thisAlias = trim($this->_article->created_by_alias);
		$thisAuthor = $this->_article->created_by;
		$matchAuthor = trim($params->get('matchAuthor', 0));
		$matchAuthorAlias = trim($params->get('matchAuthorAlias', 0));
		$noauth	= !$params->get('show_noauth');
		$anyOrAll = $params->get('anyOrAll', 'any');
		$publishedState = $params->get('fjArticleState', 1);
		
		if (($metakey) || 	// do the query if there are keywords
		($matchAuthor) || 						 	// or if the author match is on
		(($matchAuthorAlias) && ($thisAlias)))	// of if the alias match is on and an alias
		{
			$db	=$this->getDBO();
			$user	=& JFactory::getUser();
			$date =& JFactory::getDate();
			$now  = $date->toMySQL();
			$nullDate = $db->getNullDate();

			// explode the meta keys on a comma
			$keys = explode(',', $metakey);
			$likes = array ();

			// assemble any non-blank word(s)
			foreach ($keys as $key)
			{
				$key = trim($key);
				if ($key) {
					$likes[] = ',' . $this->_db->getEscaped($key) . ','; // surround with commas so first and last items have surrounding commas
				}
			}
			$ordering 	= $params->get('ordering', 'alpha');
			$sqlSort	= $this->_buildContentOrderBy($ordering);

			// set connector to OR or AND based on parameter
			$sqlConnector =  ($anyOrAll == 'any') ? ' OR ' : ' AND ';

			if (($likes) && ($anyOrAll != 'exact')) {
				$keywordSelection = ' CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%'.
				implode('%"' . $sqlConnector . 'CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%', $likes).'%"';
			}
			else if (($likes) && ($anyOrAll == 'exact')) {
				$keywordSelection = ' UPPER(a.metakey) = "' . strtoupper($metakey) . '" ';
			}
			else { // in this case we are only going to match on author or alias, so we put a harmless false selection here
				$keywordSelection = ' 1 = 2 '; // just as a placeholder (so our AND's and OR's still work)
			}
			
			// get published state select
			if (is_array($publishedState)) {
				$publishedStateCondition = implode(',', $publishedState);
			}
			else {
				$publishedStateCondition = $publishedState;
			}

			// get category section selections
			// process either as comma-delimited list or as array (for backward compatibility)
			$catid = (is_array($params->get('catid'))) ? implode(',', $params->get('catid') ) : trim($params->get('catid'));
			$secid = (is_array($params->get('secid'))) ? implode(',', $params->get('secid') ) : trim($params->get('secid'));
			$catCondition = '';
			$secCondition = '';

			if ($catid || $catid == '0')
			{
				$ids = str_replace('C', $this->_article->catid, strtoupper($catid));
				$ids = explode( ',', $ids);
				JArrayHelper::toInteger( $ids );
				$catCondition = ' AND a.catid IN (' . implode(',', $ids ) . ')';
			}
			if ($secid)
			{
				$ids = str_replace('C', $this->_article->sectionid, strtoupper($secid));
				$ids = explode( ',', $ids );
				JArrayHelper::toInteger( $ids );
				$secCondition = ' AND a.sectionid IN (' . implode(',', $ids ) . ')';
			}

			if ($matchAuthor) {
				$matchAuthorCondition = $sqlConnector . 'a.created_by = ' . $db->Quote($thisAuthor) . ' ';
			}

			if (($matchAuthorAlias) && ($thisAlias)) {
				$matchAuthorAliasCondition = $sqlConnector . 'UPPER(a.created_by_alias) = ' . $db->Quote(strtoupper($thisAlias)) . ' ';
			}
			else {
				$matchAuthorAliasCondition = ' ';
			}

			if ($noauth) {
				$noauthCondition = ' AND a.access <= ' .(int) $user->get('aid', 0);
			}

			if ($params->get('filter'))
			{
				$filterWhere = $this->_getFilterWhere($params->get('filter_type'));
			}
			else {
				$filterWhere = '';
			}

			// select other items based on the metakey field 'like' the keys found
			$query = 'SELECT a.id, a.title, a.title_alias, a.introtext, a.fulltext, DATE_FORMAT(a.created, "%Y-%m-%d") AS created, a.sectionid, a.state, a.catid, a.hits,' .
							' a.created, a.created_by, a.created_by_alias, a.modified, a.modified_by,' .
							' a.checked_out, a.checked_out_time, a.publish_up, a.publish_down, a.attribs, a.hits, a.images, a.urls, a.ordering, a.metakey, a.metadesc, a.access,' .
							' cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state,' .
							' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
							' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
							' CHAR_LENGTH( a.`fulltext` ) AS readmore, u.name AS author, g.name AS groups ' . $voting['select'] . ', ' .
							' a.metakey, "0" as match_count, "" as match_list, "" as main_article_keywords, '. // add new columns to query for counting keyword matches
							' cc.title as category, s.title as section, "article" as link_type ' .
							' FROM #__content AS a' .
							' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' .
							' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
							' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
							' LEFT JOIN #__users AS u ON u.id = a.created_by' .
							' LEFT JOIN #__groups AS g ON a.access = g.id'.
			$voting['join'].
							' WHERE a.id != '.(int) $this->_id .
							' AND a.state IN (' . $publishedStateCondition . ') ' . 
			($noauth ? $noauthCondition : '') .
							' AND ( ' .
			$keywordSelection .
			($matchAuthor ? $matchAuthorCondition : '' ) . // author match part of OR clause
			($matchAuthorAlias ? $matchAuthorAliasCondition : '') . // author alias part of OR clause
							' )' .
							' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
							' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' ) ' . 
			($secCondition ? $secCondition : '') .  // add section selection, if any
			($catCondition ? $catCondition : '') .  // add category selection, if any
			$filterWhere . // add filter selection
			$sqlSort; // sort the query
		}
		else
		{
			$query = '';
		}
		return $query;
	}



	function _reverseSort ($row1, $row2) // comp
	{
		if ($row1->match_count == $row2->match_count) // sort by title within match_count (if same # matches)
		{
			$result = strcmp ($row1->title, $row2->title);
		}
		else
		{
			$result = - strcmp ($row1->match_count, $row2->match_count); // otherwise, sort by reverse match_count
		}
		return $result;
	}

	function _normalSort ($row1, $row2) // comp
	{
		if ($row1->match_count == $row2->match_count) // sort by title within match_count (if same # matches)
		{
			$result = strcmp ($row1->title, $row2->title);
		}
		else
		{
			$result = strcmp ($row1->match_count, $row2->match_count); // otherwise, sort by reverse match_count
		}
		return $result;
	}
	/**
	 * Creates the ORDER BY clause of the query
	 * There are two cases: (1) The initial query and (2) sorting by a column header
	 * @param $orderby
	 * @return unknown_type
	 */
	function _buildContentOrderBy($defaultOrder)
	{
		global $mainframe;
		$itemid = JRequest::getInt('Itemid',0);
		$filter_order  = $mainframe->getUserStateFromRequest('com_fjrelated.list.' . $itemid . ':.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('com_fjrelated.list.' . $itemid . ':.filter_order_Dir', 'filter_order_Dir', '', 'cmd');

		$orderBy = ' ORDER BY ';
		if ($filter_order && $filter_order_Dir)
		{
			$orderBy .= $filter_order .' '. $filter_order_Dir;
		}

		if (($filter_order == 'author') && $filter_order_Dir)
		{
			$orderBy = ' ORDER BY CASE WHEN CHAR_LENGTH(a.created_by_alias) THEN a.created_by_alias ELSE u.name END '. $filter_order_Dir;
		}

		if (!($filter_order && $filter_order_Dir)) {
			switch ($defaultOrder)
			{
				case 'alpha' :
					$orderBy .= 'a.title ';
					break;

				case 'rdate' :
					$orderBy .= 'a.created desc, a.title ';
					break;

				case 'date' :
					$orderBy .= 'a.created, a.title ';
					break;

				case 'article_order' :
					$orderBy .= 's.ordering, cc.ordering, a.ordering, a.title ' ;
					break;

				default:
					$orderBy .= 'a.title ';
			}
		}

		return $orderBy;
	}
	/**
	 * Method to load content item data for related items if they don't
	 * exist.
	 *
	 * @access	private
	 * @return	boolean	True on success
	 */
	function _loadData($state = 1)
	{
		if (empty($this->_article)) {
			return false;
		}
		// Lets load the siblings if they don't already exist
		if (empty($this->_content[$state]))
		{
			// Get the pagination request variables
			$limit		= JRequest::getVar('limit', 0, '', 'int');
			$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

			$query = $this->_buildQuery();
			$Arows = $this->_getList($query, $limitstart, $limit);

			// renumber rows for pagination links (start at limitstart)
			$i = $limitstart;
			$rows = array();
			foreach ($Arows as $row)
			{
				// check to determine if section or category has proper access rights
				$rows[$i] = $row;
				$i ++;
			}

			$this->_data[$state] = $rows;
		}
		return true;
	}
	function _getList($query, $limitstart, $limit)
	{
		// Override because we have to allow
		// for the possibility of processing after the query to count
		// the number of matches
		global $mainframe;
		$db = $this->getDBO();
		$params = &$mainframe->getParams();
		$orderBy = $params->get('ordering', 'alpha');
		$showMatchList = $params->get('showMatchList', '0');
		$showCount = $params->get('showMatchCount', '0');
		$matchAuthor = $params->get('matchAuthor', 0);
		$matchAuthorAlias = $params->get('matchAuthorAlias', 0);

		// Variables to check to see if we are responding to a user column sort
		$itemid = JRequest::getVar('Itemid');
		$filter_order  = $mainframe->getUserStateFromRequest('com_fjrelated.list.' . $itemid . ':.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest('com_fjrelated.list.' . $itemid . ':.filter_order_Dir', 'filter_order_Dir', '', 'cmd');

		$user =& JFactory::getUser();
		$metakey = trim($this->_article->metakey);
		$keys = explode(',', $metakey);

		// if not sorting by best match, we can limit the sql query to the count parameter
		if (($orderBy != 'bestmatch') && ($filter_order!='match_count') && ($limit))
		{
			$db->setQuery($query, $limitstart, $limit);
		}
		else
		{
			$db->setQuery($query); // can't use $showLimit until we sort by bestmatch
		}
		$temp = $db->loadObjectList();
		$related = array();
		if (count($temp)) // we have at least one related article
		{
			// count the number of keyword matches (skip if not required based on parameter settings)
			if (($showMatchList) || ($showCount) || ($orderBy == 'bestmatch'))
			{
				foreach ($temp as $row) // loop through each related article
				{
					$rowkeywords = explode(',', trim($row->metakey)); // create array of current article's keyword phrases
					foreach ($rowkeywords as $keyword ) // loop through each keyword phrase of this related article
					{
						foreach ($keys as $nextkey) // loop through each keyword phrase of the main article
						{
							if (strtoupper(trim($keyword)) == strtoupper(trim($nextkey))) // test key match (ignore case)
							{
								$row->match_count++; // if match, increment counter
								$matching_keywords[] = trim($keyword); // if match, add this phrase to list of matches
							}
						}
					}

					// add author or alias to count and list, if applicable
					if (($matchAuthorAlias) && // check parameter
					(trim($this->_article->created_by_alias)) && // check that there is an alias
					(strtoupper(trim($row->created_by_alias)) == strtoupper(trim($this->_article->created_by_alias)))) // check match
					{
						$row->match_count++;
						$matching_keywords[] = trim($row->created_by_alias);
					}
					else if (($matchAuthor) && ($row->created_by == $this->_article->created_by)) // otherwise, check authors
					{
						$row->match_count++;
						$matching_keywords[] = trim($row->author);
					}

					$row->match_list = $matching_keywords; // save all of the matches for the current row
					$row->main_article_keywords = $keys; // save main article keywords in each row
					$matching_keywords = array(); // reset the array for the next row
				}
			}
			if ($orderBy == 'bestmatch') {
				$ii = $limitstart;
			}
			else {
				$ii = 0;
			}
			if (($orderBy == 'bestmatch' && (!$filter_order)) || (($filter_order=='match_count') && ($filter_order_Dir=='desc'))) // need to sort now that we have the count of keyword matches
			{
				usort($temp, array('FJRelatedModelFJRelated', '_reverseSort'));
				$ii = $limitstart; // we have retrieved all related articles and need to select desired range manually
			}
			else if (($filter_order=='match_count') && ($filter_order_Dir=='asc'))
			{
				usort($temp, array('FJRelatedModelFJRelated', '_normalSort'));
				$ii = $limitstart; // we have retrieved all related articles and need to select desired range manually
			}
			if (!$limit) $limit = count($temp); // loop through all if All selected
			for ($i=$ii; $i < min($limit + $limitstart, count($temp)); $i++)
			{
				$row = $temp[$i];
				if (($row->cat_state == 1 || $row->cat_state == '') && ($row->sec_state == 1 || $row->sec_state == '') && ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') && ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == ''))
				{
					$row->route = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
					$related[] = $row;
				}
			}
		}
		unset ($temp);
		return $related;
	}

	/**
	 * Method to add filter to SQL Where clause
	 * @access private
	 * @return string value of where clause for filter
	 */
	function _getFilterWhere($filterType)
	{
		$filter = JRequest::getString('filter', '', 'request');
//		global $mainframe;
//		$itemid = JRequest::getVar('Itemid');
//		$filter	= $mainframe->getUserStateFromRequest('com_fjrelated.list.' . $itemid . ':.filter', 'filter', '', 'cmd');

		$filterWhere = '';
		if ($filter)
		{
			// clean filter variable
			$filter = JString::strtoupper($filter);
			$hitsFilter = intval($filter);
			$filter	= $this->_db->Quote( '%'.$this->_db->getEscaped( $filter, true ).'%', false );

			switch ($filterType)
			{
				case 'title' :
					$filterWhere = ' AND UPPER( a.title ) LIKE '.$filter;
					break;

				case 'author' :
					$filterWhere = ' AND ( ( UPPER( u.name ) LIKE '.$filter.' ) OR ( UPPER( a.created_by_alias ) LIKE '.$filter.' ) )';
					break;

				case 'hits' :
					$filterWhere = ' AND a.hits >= '.$hitsFilter. ' ';
					break;
			}
		}
		return $filterWhere;
	}
	/**
	 * Check to see if this is an FJ Related Intro Article
	 * If it is, return the link to the FJ Related Layout
	 * @param $id Id of article to check
	 * @param $layout layout (blog or default)
	 * @return string - link if menu item exists
	 */
	function getRelatedLayoutLink($id, $layout) {
		if ($this->_fjrelatedLinks == null) { // do query only the first time
			$query_string = "'%option=com_fjrelated&view=fjrelated%'";
			$user		=& JFactory::getUser();
			$aid		= (int) $user->get('aid', 0);
			$query = "SELECT link, CONCAT('index.php?Itemid=', id) as itemid " .
				 ' FROM #__menu WHERE link LIKE ' . $query_string .
				 ' AND access <= ' . $aid . 
				 ' AND published = 1';
			$db = $this->_db;
			$db->setQuery($query);
			$this->_fjrelatedLinks = $db->loadObjectList();
		}
		$matchingBlog = '';
		$matchingList = '';
		$result = '';
		foreach ($this->_fjrelatedLinks as $item) { // read through all fjrelated menu items
			if (strpos($item->link, 'layout=blog&id=' . $id)) {
				$matchingBlog = $item->itemid; // save the matching blog
			}
			if (strpos($item->link, 'view=fjrelated&id=' . $id)) {
				$matchingList = $item->itemid; // save the matching list item
			}
		}
		// return the best match
		if (($matchingBlog) && ($matchingList)) { // if id has a list and blog, get same layout
			if ($layout == 'default') {
				$result = $matchingList;
			}
			else {
				$result = $matchingBlog;
			}
		}
		else { // if we only have one match, take the one with a value
			$result = ($matchingList) ? $matchingList : $matchingBlog;
		}
		return $result;
	}

}
