<?php	// modified by RJA J15 for Joomla! 1.5 compatibility and improvements

// MambWeather 2.3.1 module - build 101108
// (c) 2004 Vasco Nunes - www.vasconunes.com
// (c) 2009-2010 INNATO BV - www.innato.nl
// **************************************************************************
// a metar station weather fetching module
// originally for Joomla! 1.0.X this version for Joomla! 1.5.X
// **************************************************************************

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );

// Get the right language if it exists. If not, defaults to english.
 $lang =& JFactory::getLanguage();
 $langTag = $lang->getTag();
// $langTag = 'en-GB';	// force language - for testing

if (file_exists(JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/language/' . $langTag . '.php'))
{
    include_once(JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/language/' . $langTag . '.php');

}
else
{
    include_once(JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/language/en-GB.php');
}

//error_reporting(E_ALL);

$station_temp		=NULL;
$location_temp		=NULL;
$marquee_output_c   =NULL;
$marquee_output_f   =NULL;

$phenomena_array = array ('#'  => '---',
                                'TS' => @$language['Thunder'],
                                'RA' => @$language['Rain'],
                                'DZ' => @$language['Rain'],
                                'SN' => @$language['Snow'],
                                'SG' => @$language['Snow'],
                                'GR' => @$language['Hail'],
                                'GS' => @$language['Hail'],
                                'PE' => @$language['Hail'],
                                'IC' => @$language['Hail'],
                                'BR' => @$language['Fog'],
                                '' => '---',
                                'FG' => @$language['Fog']);
                                
$wind_dir = array (0 => '',
                                1 => @$language['NNE'],
                                2 => @$language['NE'],
                                3 => @$language['NEE'],
                                4 => @$language['E'],
                                5 => @$language['SEE'],
                                6 => @$language['SE'],
                                7 => @$language['SSE'],
                                8 => @$language['S'],
                                9 => @$language['SSW'],
                                10 => @$language['SW'],
                                11 => @$language['SWW'],
                                12 => @$language['W'],
                                13 => @$language['NWW'],
                                14 => @$language['NW'],
                                15 => @$language['NNW'],
                                16 => @$language['N']);                                

@session_start();
header("Cache-control: private");

require_once  JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/metar.class.php';
require_once JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/Savant2.php';

// get the parameters
$params = new JParameter( $module->params );

$station=array();
if ($params->get('station')!=='') {
	$station = explode(',',$params->get('station'));
}
else
{
	$station = explode(',','EHAM,KNYC,RJAA');
}

$location=array();
if ($params->get('location')!=='') {
	$location = explode(',',$params->get('location'));
}
else
{
	$location = explode(',','Amsterdam,New York,Tokyo');
}

if ($params->get('cache_timeout')!=='') {
	$cache_timeout = $params->get('cache_timeout');
}
else
{
	$cache_timeout = 1800;
}

if ($params->get('param_display_width_px') != '') {
	$param_display_width_px = 'width: '.$params->get('param_display_width_px').'px; ';
	$param_display_width_table = '';
}
else
{
	$param_display_width_table = 'width: 100%; ';
	$param_display_width_px = '';
}

if ($params->get('template')!=='') {
	$template = $params->get('template');
}
else
{
	$template = 'metric';
}

if ($params->get('weather_icon_show')!=='') {
	$weather_icon_show = $params->get('weather_icon_show');
}
else
{
	$weather_icon_show = 'yes';
}

if ($params->get('icon_set')!=='') {
	$icon_set = $params->get('icon_set');
}
else
{
	$icon_set = 'iconset1';
}

if ($params->get('use_marquee')!=='') {
	$use_marquee = $params->get('use_marquee');
}
else
{
	$use_marquee = 'yes';
}

if ($params->get('offset')!=='') {
	$offset = $params->get('offset');
}
else
{
	$offset = '0';
}

// convert offset from decimal hour (e.g. 5.75) to hh.mm (e.g. 5.45)
$temp = intval($offset);
$offset = $temp + 0.6*($offset - $temp);

if ($params->get('marquee_with_icons')!=='') {
	$marquee_with_icons = $params->get('marquee_with_icons');
}
else
{
	$marquee_with_icons = 'no';
}

if ($params->get('marquee_icons_size')!=='') {
	$marquee_icons_size = $params->get('marquee_icons_size');
}
else
{
	$marquee_icons_size = '32';
}


if ($params->get('metar_temp_separator')!=='') {
	$metar_temp_separator = $params->get('metar_temp_separator');
}
else
{
	$metar_temp_separator = 'yes';
}

if ($params->get('details_list')!=='') {
	$details_list = $params->get('details_list');
}
else
{
	$details_list = 'yes';
}

if ($params->get('details_list_default')!=='') {
	$details_list_default = $params->get('details_list_default');
}
else
{
	$details_list_default = 'no';
}


if ($params->get('location_selection')!=='') {
	$location_selection = $params->get('location_selection');
}
else
{
	$location_selection = 'yes';
}

$time_zone=array();
if ($params->get('time_zone')!=='') {
	$time_zone = explode(',',$params->get('time_zone'));
}
else
{
	$time_zone = explode(',','1,-6,9');
}

if ($params->get('metar_mode')!=='') {
	$metar_mode = $params->get('metar_mode');
}
else
{
	$metar_mode = 'HTTP';
}

if ($params->get('param_font_type')!=='') {
	$param_font_type = $params->get('param_font_type');
}
else
{
	$param_font_type = '#arial, helvetica, sans-serif';
}

$param_font_style_description = $params->get('param_font_style_description');
if ($param_font_style_description !== '') {
	$param_font_style_description_open_tag = '<'.$param_font_style_description.'>';
	$param_font_style_description_close_tag = '</'.$param_font_style_description.'>';
}
else
{
	$param_font_style_description_open_tag = '';
	$param_font_style_description_close_tag = '';
}


if ($params->get('param_font_colour_description')!=='') {
	$param_font_colour_description = $params->get('param_font_colour_description');
}
else
{
	$param_font_colour_description = '#fff';
}

if ($params->get('param_font_colour_temperature')!=='') {
	$param_font_colour_temperature = $params->get('param_font_colour_temperature');
}
else
{
	$param_font_colour_temperature = '#ffff00';
}

if ($params->get('param_font_colour_marquee')!=='') {
	$param_font_colour_marquee = $params->get('param_font_colour_marquee');
}
else
{
	$param_font_colour_marquee = '#000000';
}

if ($params->get('param_font_colour_details')!=='') {
	$param_font_colour_details = $params->get('param_font_colour_details');
}
else
{
	$param_font_colour_details = '#000000';
}

if ($params->get('param_bg_colour_descr_temp')!=='') {
	$param_bg_colour_descr_temp = $params->get('param_bg_colour_descr_temp');
}
else
{
	$param_bg_colour_descr_temp = '#666666';
}

if ($params->get('param_bg_colour_marquee')!=='') {
	$param_bg_colour_marquee = $params->get('param_bg_colour_marquee');
}
else
{
	$param_bg_colour_marquee = '#cccccc';
}

if ($params->get('param_bg_colour_details_left')!=='') {
	$param_bg_colour_details_left = $params->get('param_bg_colour_details_left');
}
else
{
	$param_bg_colour_details_left = '#cccccc';
}

if ($params->get('param_bg_colour_details_right')!=='') {
	$param_bg_colour_details_right = $params->get('param_bg_colour_details_right');
}
else
{
	$param_bg_colour_details_right = '#aaaaaa';
}


$sunrise_hour=array();
if ($params->get('sunrise_hour')!=='') {
	$sunrise_hour = explode(',',$params->get('sunrise_hour'));
}
else
{
	$sunrise_hour = explode(',','6,6,6');
}

$sunset_hour=array();
if ($params->get('sunset_hour')!=='') {
	$sunset_hour = explode(',',$params->get('sunset_hour'));
}
else
{
	$sunset_hour = explode(',','18,18,18');
}

// store some params for passing - RJA
$_SESSION['weather_icon_show'] = $weather_icon_show;
$_SESSION['details_list'] = $details_list;
$_SESSION['details_list_default'] = $details_list_default;
$_SESSION['location_selection'] = $location_selection;
$_SESSION['metar_mode'] = $metar_mode;
$_SESSION['param_display_width_px'] = $param_display_width_px;
$_SESSION['param_display_width_table'] = $param_display_width_table;
$_SESSION['metar_temp_separator'] = $metar_temp_separator;
$_SESSION['param_font_type'] = $param_font_type;
$_SESSION['param_font_style_description_open_tag'] = $param_font_style_description_open_tag;
$_SESSION['param_font_style_description_close_tag'] = $param_font_style_description_close_tag;
$_SESSION['param_font_colour_description'] = $param_font_colour_description;
$_SESSION['param_font_colour_temperature'] = $param_font_colour_temperature;
$_SESSION['param_font_colour_marquee'] = $param_font_colour_marquee;
$_SESSION['param_font_colour_details'] = $param_font_colour_details;
$_SESSION['param_bg_colour_descr_temp'] = $param_bg_colour_descr_temp;
$_SESSION['param_bg_colour_marquee'] = $param_bg_colour_marquee;
$_SESSION['param_bg_colour_details_left'] = $param_bg_colour_details_left;
$_SESSION['param_bg_colour_details_right'] = $param_bg_colour_details_right;

// check if the form has passed some value
$station_selected=JArrayHelper::getValue( $_REQUEST, 'selectbox');

if ( $station_selected<>NULL )
{
    $station_temp=$station[$station_selected];
	// store params for passing
	$_SESSION['station_selected'] = $station_selected;
}

if ($station_temp=='')
{
    $station_temp=$station[0];
    $station_selected=0;
}

// check if we have a session value stored
if ( ( @$_SESSION['station_temp'] ) && ( $station_selected==NULL ) )
{
    $station_temp=$_SESSION['station_temp'];
    $location_temp=$_SESSION['location_temp'];
    $station_selected=$_SESSION['station_selected'];
	$time_zone=$_SESSION['time_zone'];
	$sunrise_hour=$_SESSION['sunrise_hour'];
	$sunset_hour=$_SESSION['sunset_hour'];
}
else
{
	// store params for passing - RJA mod
    $_SESSION['station_temp']=$station_temp;
    $_SESSION['location_temp']=$location_temp;
    $_SESSION['station_selected']=$station_selected;
	$_SESSION['time_zone'] = $time_zone;
	$_SESSION['sunrise_hour'] = $sunrise_hour;
	$_SESSION['sunset_hour'] = $sunset_hour;

}

// delete old metar cache data
$dir = JPATH_SITE."/modules/mod_mambweather/mod_mambweather/metar_data/";
$filename = '';
$mydir = opendir($dir);
while(false !== ($file = readdir($mydir))) {
	if($file != "." && $file != "..") {
			if(($filename =='' || $file == $filename) && $file != "index.html" && $file != "index.htm") {
				$file_age=(time()-filemtime($dir.$file));
//				echo $file." = ".$file_age."<br />";
				if ($file_age > 86400) {	// delete all metar cache data older than 1 day
               		unlink($dir.$file);
				}
				if (substr($file,-13) == 'overlayed.png') {	// delete all overlayed icon cache files - needed to prevent display of cached overlay image when metar data too old
               		unlink($dir.$file);
				}
			}
	}
}
closedir($mydir);

$weather = new weatherMetar;
$weather->cache=$cache_timeout;
$weather->offset=$offset;

$marquee_output = "";
$count_station=0;

// used for marquee scroll
if ($use_marquee=='yes')
{
 foreach ($station as $station_t)
 {
 	$marquee=$weather->decode_metar($weather->getMetar($station_t));

    if ($marquee_with_icons=='yes') {
        $marquee_output_c .= "&nbsp;&nbsp;&nbsp;<img width='$marquee_icons_size' align='bottom' vspace='1' border='1' src='".JURI::base()
."/modules/mod_mambweather/mod_mambweather/templates/icons/".$icon_set."/".$weather->get_sky_image($marquee)."' /> ";
        $marquee_output_f .= "&nbsp;&nbsp;&nbsp;<img width='$marquee_icons_size' align='bottom' vspace='1' border='1' src='".JURI::base()
."/modules/mod_mambweather/mod_mambweather/templates/icons/".$icon_set."/".$weather->get_sky_image($marquee)."' /> ";
    }

    $marquee_output_c .= $location[$count_station].' '.@$marquee['temperature']['temp_c']."&deg;C";
    $marquee_output_f .= $location[$count_station].' '.@$marquee['temperature']['temp_f']."&deg;F";

    if (count($station) > $count_station+1 && $marquee_with_icons=='no')

	{
		$marquee_output_c .= ' | ';
		$marquee_output_f .= ' | ';
	}
	$count_station++;
 }
}

$processed_metar=$weather->decode_metar( $weather->getMetar($station_temp) );

// initialize template system
$conf = array(
	'template_path' => JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/templates/'.$template,
	'resource_path' => ''
);
$savant = new Savant2($conf);

// assign variables to template
$savant->assign('icon',JURI::base()
.'modules/mod_mambweather/mod_mambweather/templates/icons/'.$icon_set.'/'.$weather->get_sky_image($processed_metar));
$savant->assign('time',@$weather->decoded_metar['time'] ? gmdate('H:i', $weather->decoded_metar['time']) : '---');

// RJA addition - if metar data too old, overlay icon with broken calendar
$local_timestamp = time() + $offset*3600;
$metar_readings_age_mins = floor(($local_timestamp - @$weather->decoded_metar['time'])/60);

if($metar_readings_age_mins >= 360) {	// display broken calendar icon when metar readings older than 6 hours
	$metar_iconpath = JPATH_SITE.'/modules/mod_mambweather/mod_mambweather/templates/icons/'.$icon_set.'/';
	$orig_metar_filename = $weather->get_sky_image($processed_metar);
	$orig_metar_img = imagecreatefrompng($metar_iconpath.$orig_metar_filename);
	$overlay_metar_img = imagecreatefrompng($metar_iconpath."calendar_broken.png");
	$mambweather_cachedir = '/modules/mod_mambweather/mod_mambweather/metar_data/';

	$orig_metar_x = imagesx($orig_metar_img);
	$orig_metar_y = imagesy($orig_metar_img);
	$overlay_metar_x = imagesx($overlay_metar_img);
	$overlay_metar_y = imagesy($overlay_metar_img);

	/* create the new image, and scale the original into it */
	$new_metar_image = imagecreatetruecolor($orig_metar_x, $orig_metar_y);
	imagecopyresampled($new_metar_image, $orig_metar_img, 0, 0, 0, 0, $orig_metar_x, $orig_metar_y, $orig_metar_x, $orig_metar_y);
	
	// make sure that transparent images do not end up with a black background
    imagesavealpha($new_metar_image, true);
    $trans_colour = imagecolorallocatealpha($new_metar_image, 0, 0, 0, 127);
    imagefill($new_metar_image, 0, 0, $trans_colour);

	
	/* set the transparant color in the overlay, and copy it into the new image */
	imagecopymerge($new_metar_image, $overlay_metar_img, 0, $orig_metar_y - $overlay_metar_y - 2, 0, 0, $overlay_metar_x, $overlay_metar_y, 100);

	/* write new image with timestamp  */
	$mambweather_timestamp = time();
	imagepng($new_metar_image, JPATH_SITE.$mambweather_cachedir.$mambweather_timestamp.'_overlayed.png');

	/* assign icon to template */
	$savant->assign('icon',JURI::base().$mambweather_cachedir.$mambweather_timestamp.'_overlayed.png');

	/* free memory */
	imagedestroy($orig_metar_img);
	imagedestroy($overlay_metar_img);
	imagedestroy($new_metar_image);
	}
// end RJA add


// RJA addition - if temperature string non-existing replace by '---'
if(!strlen(@$weather->decoded_metar['temperature']['temp_c'])) {
	$weather->decoded_metar['temperature']['temp_c'] = "---";
	$weather->decoded_metar['temperature']['temp_f'] = "---";
	$savant->assign('icon',JURI::base()
.'modules/mod_mambweather/mod_mambweather/templates/icons/'.$icon_set.'/no_metar.png');
	}
// end RJA add

$savant->assign('temperature_c',@$weather->decoded_metar['temperature']['temp_c'] ? $weather->decoded_metar['temperature']['temp_c'].' &deg;C' : '0 &deg;C'); // RJA mod
$savant->assign('temperature_f',@$weather->decoded_metar['temperature']['temp_f'] ? $weather->decoded_metar['temperature']['temp_f'].' &deg;F' : '0 &deg;F'); // RJA mod
$savant->assign('dew_c',@$weather->decoded_metar['temperature']['dew_c'] ? $weather->decoded_metar['temperature']['dew_c'].' &deg;C' : '---');
$savant->assign('dew_f',@$weather->decoded_metar['temperature']['dew_f'] ? $weather->decoded_metar['temperature']['dew_f'].' &deg;F' : '---');
$savant->assign('condition',@$phenomena_array[$weather->phenomena] ? @$phenomena_array[$weather->phenomena] : '---');
$savant->assign('location',@$location[$station_selected]);
if(strstr(@$weather->decoded_metar['wind']['deg'],"VRB")) @$weather->decoded_metar['wind']['deg']=$language['Variable'];
$savant->assign('wind_deg',@$weather->decoded_metar['wind']['deg'] ? @$weather->decoded_metar['wind']['deg'].@$wind_dir[$weather->get_wind_dir()] : '---');
$savant->assign('wind_var_beg',@$weather->decoded_metar['wind']['var_beg'] ? $weather->decoded_metar['wind']['var_beg'].'&deg;' : '---');
$savant->assign('wind_var_end',@$weather->decoded_metar['wind']['var_end'] ? $weather->decoded_metar['wind']['var_end'].'&deg;' : '---');
$savant->assign('wind_knots',@$weather->decoded_metar['wind']['knots'] ? $weather->decoded_metar['wind']['knots'].' kts' : '---');
$savant->assign('wind_meters_per_second',@$weather->decoded_metar['wind']['meters_per_second'] ? $weather->decoded_metar['wind']['meters_per_second'].' m/s' : '---');
$savant->assign('wind_miles_per_hour',@$weather->decoded_metar['wind']['miles_per_hour'] ? $weather->decoded_metar['wind']['miles_per_hour'].' mph' : '---');
$savant->assign('wind_gust_knots',@$weather->decoded_metar['wind']['gust_knots'] ? $weather->decoded_metar['wind']['gust_knots'].' kts' : '---');
$savant->assign('wind_gust_meters_per_second',@$weather->decoded_metar['wind']['gust_meters_per_second'] ? $weather->decoded_metar['wind']['gust_meters_per_second'].' m/s' : '---');
$savant->assign('wind_gust_miles_per_hour',@$weather->decoded_metar['wind']['gust_miles_per_hour'] ? $weather->decoded_metar['wind']['gust_miles_per_hour'].' mph' : '---');
$savant->assign('visibility_km',@$weather->decoded_metar['visibility']['km'] ? $weather->decoded_metar['visibility']['km']." km" : '---');
$savant->assign('visibility_meter',@$weather->decoded_metar['visibility']['meter'] ? $weather->decoded_metar['visibility']['meter']." m" : '---');
$savant->assign('visibility_miles',@$weather->decoded_metar['visibility']['miles'] ? $weather->decoded_metar['visibility']['miles']." m" : '---');
$savant->assign('altimeter_hpa',@$weather->decoded_metar['altimeter']['hpa'] ? $weather->decoded_metar['altimeter']['hpa'].' hPa' : '---');
$savant->assign('altimeter_mmhg',@$weather->decoded_metar['altimeter']['mmhg'] ? $weather->decoded_metar['altimeter']['mmhg'].' mmHg' : '---');
$savant->assign('altimeter_inhg',@$weather->decoded_metar['altimeter']['inhg'] ? $weather->decoded_metar['altimeter']['inhg'].' inHg' : '---');
$savant->assign('altimeter_atm',@$weather->decoded_metar['altimeter']['atm'] ? $weather->decoded_metar['altimeter']['atm'].' atm' : '---');
$savant->assign('rel_humidity',@$weather->decoded_metar['rel_humidity'] ? $weather->decoded_metar['rel_humidity']." %" : '---');
$savant->assign('windchill_c',@$weather->decoded_metar['windchill']['windchill_c'] ? $weather->decoded_metar['windchill']['windchill_c'].' &deg;C' : '---');
$savant->assign('windchill_f',@$weather->decoded_metar['windchill']['windchill_f'] ? $weather->decoded_metar['windchill']['windchill_f'].' &deg;F' : '---');
$savant->assign('heatindex_c',@$weather->decoded_metar['heatindex']['heatindex_c'] ? $weather->decoded_metar['heatindex']['heatindex_c'].' &deg;C' : '---');
$savant->assign('heatindex_f',@$weather->decoded_metar['heatindex']['heatindex_f'] ? $weather->decoded_metar['heatindex']['heatindex_f'].' &deg;F' : '---');
$savant->assign('humidex_c',@$weather->decoded_metar['humidex']['humidex_c'] ? $weather->decoded_metar['humidex']['humidex_c']." &deg;C" : '---');
$savant->assign('humidex_f',@$weather->decoded_metar['humidex']['humidex_f'] ? $weather->decoded_metar['humidex']['humidex_f']." &deg;F" : '---');
$savant->assign('precipitation_mm',@$weather->decoded_metar['precipitation']['mm_24h'] ? $weather->decoded_metar['precipitation']['mm_24h']." mm" : '---');
$savant->assign('precipitation_in',@$weather->decoded_metar['precipitation']['in_24h'] ? $weather->decoded_metar['precipitation']['in_24h']." in" : '---');
$savant->assign('snow_in',@$weather->decoded_metar['precipitation']['snow_in'] ? $weather->decoded_metar['precipitation']['snow_in']." in" : '---');
$savant->assign('snow_mm',@$weather->decoded_metar['precipitation']['snow_mm'] ? $weather->decoded_metar['precipitation']['snow_mm']." mm" : '---');
$option_location = $location;
$selected_value = $station_selected;
$savant->assign('options', $option_location);
$savant->assign('selected', $selected_value);

// passing the language strings to the template
$savant->assign('language', $language);

if ($use_marquee=='yes')
{
	//marquee
	$savant->assign('scroll_info_c','<MARQUEE loop="-1" scrollamount="2" width="100%">'.$marquee_output_c.'</MARQUEE>');
	$savant->assign('scroll_info_f','<MARQUEE loop="-1" scrollamount="2" width="100%">'.$marquee_output_f.'</MARQUEE>');
} else {
    $savant->assign('scroll_info_c','');
    $savant->assign('scroll_info_f','');
}

// display template
$savant->display('template.tpl.php');
?>