<?php
/**
 * @package Plugin Media Slideshow FX for Joomla! 1.5
 * @version $Id: mod_mediaslideshowfx.php 6 October 2010 $
 * @author FlashXML.net
 * @copyright (C) 2010 FlashXML.net
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plgcontentmediaslideshowfx');
$mediaslideshowfx_embed_codes_count = 0;
$mediaslideshowfx_swfobject_embedded = false;

function plgcontentmediaslideshowfx(&$row, &$params, $page=0) {
	if (is_object($row)) {
		return plgmediaslideshowfx($row->text, $params);
	}
	return plgmediaslideshowfx($row, $params);
}

function plgmediaslideshowfx(&$text, &$params) {
	if (JString::strpos($text, '{mediaslideshowfx') === false) {
		return true;
	}

	$text = preg_replace_callback('|{mediaslideshowfx\s*(settings="([^"]+)")?\s*(width="([0-9]+)")?\s*(height="([0-9]+)")?\s*}(.*){/mediaslideshowfx}|i', 'plgmediaslideshowfxembedcode', $text);
	return true;
}

function plgmediaslideshowfxembedcode($params) {
	$mediaslideshowfx_plugin_helper = JPluginHelper::getPlugin('content', 'mediaslideshowfx');
	$pluginParams = new JParameter($mediaslideshowfx_plugin_helper->params);
	$mediaslideshow_path = $pluginParams->get('mediaslideshowfx_path');
	if (strpos($mediaslideshow_path, '/') !== 0) {
		$mediaslideshow_path = '/' . $mediaslideshow_path;
		$pluginParams->def('mediaslideshowfx_path', $path);
	}
	$swf = 'MediaSlideshowFX.swf';
	$settings = !empty($params[2]) ? $params[2] : 'settings.xml';
	global $mediaslideshowfx_swfobject_embedded;
	if (empty($mediaslideshowfx_swfobject_embedded)) {
		global $mainframe;
		$mainframe->addCustomHeadTag('<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/swfobject/2.2/swfobject.js"></script>');
		$mediaslideshowfx_swfobject_embedded = true;
	}

	$mediaslideshowfx_width = $mediaslideshowfx_height = 0;
	if (function_exists('simplexml_load_file') && file_exists(JPATH_SITE.$mediaslideshow_path.$settings)) {
		$xml = simplexml_load_file(JPATH_SITE.$mediaslideshow_path.$settings);
		if ($xml) {
			$mediaslideshowfx_width = (int)$xml->General_Properties->componentWidth->attributes()->value;
			$mediaslideshowfx_height = (int)$xml->General_Properties->componentHeight->attributes()->value;
		}
	}
	if ($mediaslideshowfx_width == 0 || $mediaslideshowfx_height == 0) {
		if ((int)$params[4] > 0 && (int)$params[6] > 0) {
		$mediaslideshowfx_width = (int)$params[4];
		$mediaslideshowfx_height = (int)$params[6];
		} else {
			return '<!-- invalid Media Slideshow FX width and / or height -->';
			}
	}

	global $mediaslideshowfx_embed_codes_count;
	$mediaslideshowfx_embed_codes_count++;

	$joomla_install_dir_in_url = rtrim(JURI::root(true), '/');
	if (!empty($joomla_install_dir_in_url) && strpos($joomla_install_dir_in_url, '/') !== 0) {
		$joomla_install_dir_in_url = '/' . $joomla_install_dir_in_url;
	}

	return '<div id="mediaslideshowfx'.$mediaslideshowfx_embed_codes_count.'">'.$params[7].'</div><script type="text/javascript">'."swfobject.embedSWF('{$joomla_install_dir_in_url}{$mediaslideshow_path}{$swf}', 'mediaslideshowfx{$mediaslideshowfx_embed_codes_count}', '{$mediaslideshowfx_width}', '{$mediaslideshowfx_height}', '9.0.0.0', '', { folderPath: '{$joomla_install_dir_in_url}{$mediaslideshow_path}'".($settings != 'settings.xml' ? ", settingsXML: '{$settings}'" : '')." }, { scale: 'noscale', salign: 'tl', wmode: 'transparent', allowScriptAccess: 'sameDomain', allowFullScreen: true }, {});</script>";
}
